#include <iostream>
#include <memory>
#include <vector>

using namespace std;


shared_ptr<int> foo(shared_ptr<int> ptr){

  shared_ptr<int> lptr = ptr;
  if(lptr)
    ++(*lptr);
  return lptr;
}

int multiply(int x, int y){
  return x * y;
}

int main(){

  shared_ptr<int> aptr = make_shared<int>(41);
  shared_ptr<int> bptr = foo(aptr);
  cout << "answer is " << *bptr << endl;


  vector<int> v{3,4,12,-1,4,5};
  for(auto it = v.begin(); it != v.end(); )
    if(*it == 4)
      it=v.erase(it);
    else{
      *it=10;
      ++it;
    }

  for(auto it = v.begin(); it != v.end(); ++it)
    cout << *it << endl;

  int x = 5;
  cout << multiply(x, ++x) << endl;
  
  
  // auto it = v.begin();
  // int* first = &v[0];

  // //  v.push_back(2);

  // cout << *it << " " << *first << endl;

  return 0;
}
